<?php
/*
Plugin Name: Category Post HighLights
Plugin URI: http://www.gbtutorials.net/
Description: Displays a list of the latest post in each category.
Author: shongaks
Version: 0.1
Author URI: http://www.gelbeltran.com
Based from: Latest From Each Category v1.7 by Dagon Design <http://www.dagondesign.com>
*/
$cph_version = '0.11';

function cph_add_option_pages() {
	if (function_exists('add_options_page')) {
		add_options_page('Category Post HighLights', 'CatPost HighLights', 1, __FILE__, 'cph_options_page');
	}		
}

function cph_options_page() {
	global $cph_version;
	
	
	if (isset($_POST['set_defaults']) ) {
		echo '<div id="message" class="updated fade" style="background-color: rgb(255, 251, 204);"><p><strong>';

		update_option('cph_sort', 'cata');
		update_option('cph_hide_protected', TRUE);
		update_option('cph_chars', 200);
		update_option('cph_limit', 0);
			
		echo 'Default Options Loaded!';
		echo '</strong></p></div>';
	}else if (isset($_POST['info_update'])) {
		echo '<div id="message" class="updated fade" style="background-color: rgb(255, 251, 204);"><p><strong>';
		update_option('cph_sort', (string) $_POST["cph_sort"]);
		update_option('cph_hide_protected', (bool)$_POST["cph_hide_protected"]);
		update_option('cph_chars', (string) $_POST["cph_chars"]);
		update_option('cph_limit', (string) $_POST["cph_limit"]);
		
		echo 'Configuration Updated!';
		echo '</strong></p></div>';
	}
	
	 ?>
	
	<div class="wrap">

		<h2>Category Post HighLights v<?php echo $cph_version; ?></h2>
	
		
		<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
			<fieldset class="options"> 
			<legend>Options</legend>
			<table width="100%" border="0" cellspacing="0" cellpadding="6">
		
			<tr valign="top"><td width="35%" align="right">
				Sort order
			</td><td align="left">
				<input name="cph_sort" type="radio" value="cata" <?php echo (get_option('cph_sort') == "cata")?"checked='checked'":''; ?> />&nbsp;&nbsp; By category (ascending)<br />
				<input name="cph_sort" type="radio" value="catd" <?php echo (get_option('cph_sort') == "catd")?"checked='checked'":''; ?> />&nbsp;&nbsp; By category (descending)<br />
				<input name="cph_sort" type="radio" value="datea" <?php echo (get_option('cph_sort') == "datea")?"checked='checked'":''; ?> />&nbsp;&nbsp; By date (ascending)<br />
				<input name="cph_sort" type="radio" value="dated" <?php echo (get_option('cph_sort') == "dated")?"checked='checked'":''; ?> />&nbsp;&nbsp; By date (descending)<br />
			</td></tr>
			</table>
			
      <table width="100%" border="0" cellspacing="0" cellpadding="6">	
			<tr valign="top"><td width="35%" align="right">
				Hide password-protected posts
			</td><td align="left">
				<input type="checkbox" name="cph_hide_protected" value="checkbox" <?php if (get_option('cph_hide_protected')) echo "checked='checked'"; ?>/>
			</td></tr>
		
			<tr valign="top"><td width="35%" align="right">
				Number of characters to show
			</td><td align="left">
				<input name="cph_chars" type="text" size="10" value="<?php echo get_option('cph_chars') ?>"/>
			</td></tr>
		
			<tr valign="top"><td width="35%" align="right">
				# of categories to show
			</td><td align="left">
				<input name="cph_limit" type="text" size="10" value="<?php echo get_option('cph_limit') ?>"/>
				(0 = unlimited); be careful as the tabs might overlap
			</td></tr>
			</table>
			</fieldset>
		
			<div class="submit">
				<input type="submit" name="set_defaults" value="<?php _e('Load Default Options'); ?> &raquo;" />
				<input type="submit" name="info_update" value="<?php _e('Update options'); ?> &raquo;" />
			</div>
		</form>
	</div>
	
	<?php
}

function cphl() {

	global $wpdb, $post, $wp_version, $color;

	$ver = (float)$wp_version;
	
	$tp = $wpdb->prefix;

	$cph_sort = get_option('cph_sort');
	$cph_hide_protected = get_option('cph_hide_protected');
	$cph_chars = (int)get_option('cph_chars');
	$cph_limit = (int)get_option('cph_limit');


	$hide_check = '';
	if ($cph_hide_protected) {
		$hide_check = " AND post_password = '' ";
	}	

	$sort_code = 'ORDER BY cat_name ASC, post_date DESC';

	switch ($cph_sort) {
		case 'cata':
			$sort_code = 'GROUP BY cat_name, post_date DESC';			
			break; 
		case 'catd':
			$sort_code = 'ORDER BY cat_name DESC, post_date DESC';		
			break;	
		case 'datea':
			$sort_code = 'ORDER BY post_date ASC'; 						
			break;	
		case 'dated':
			$sort_code = 'ORDER BY post_date DESC';						 
			break;	
	}	

	$the_output = NULL;


	if ($ver < 2.3) {

		$last_posts = (array)$wpdb->get_results("
			SELECT post_date, ID, post_title, cat_name, cat_ID
			FROM {$tp}posts, {$tp}post2cat, {$tp}categories 
			WHERE {$tp}posts.ID = {$tp}post2cat.post_id 
			AND {$tp}categories.cat_ID = {$tp}post2cat.category_id
			AND post_status = 'publish' 
			AND post_type != 'page' 
			AND post_date < NOW() 
			{$hide_check} 
			{$sort_code}
		");

	} else { // post 2.3

		$last_posts = (array)$wpdb->get_results("
			SELECT post_date, 
				ID, 
				post_title, 
				{$tp}terms.name as cat_name, 
				{$tp}terms.term_id as cat_ID
			FROM {$tp}posts, {$tp}terms, {$tp}term_taxonomy, {$tp}term_relationships
			WHERE {$tp}posts.ID = {$tp}term_relationships.object_id 
			AND {$tp}term_relationships.object_id = {$tp}posts.ID
			AND {$tp}term_relationships.term_taxonomy_id = {$tp}term_taxonomy.term_taxonomy_id 
			AND {$tp}terms.term_id  = {$tp}term_taxonomy.term_id 
			AND {$tp}term_taxonomy.taxonomy = 'category' 
			AND post_status = 'publish' 
			AND post_type = 'post' 
			AND post_date < NOW() 
			{$hide_check} 
			{$sort_code}
		");



	}

	if (empty($last_posts)) {
		return NULL;
	}


	if ($cph_sort == 'datea') {
			$last_posts = array_reverse($last_posts);
		}



	$used_cats = array();;
	$i = 0;
	foreach ($last_posts as $posts) {

		if (in_array($posts->cat_name, $used_cats)) {
			unset($last_posts[$i]);
		} else {
			$used_cats[] = $posts->cat_name;
		}

		$i++;
	}
	$last_posts = array_values($last_posts);


	update_option('ucat', $last_posts);

		if ($cph_sort == 'datea') {
			$last_posts = array_reverse($last_posts);
		}
	if($cph_limit==0)
		$r = count($used_cats);
	else
		$r = $cph_limit;
	
	$output = '<script type="text/javascript"> ';
	$output .= 'function swaplayers(linkId,divId) {	
	for (x=1;x<='.$r.';x++){
		var dynalinks = \'link\' + x;
		var dynadiv = \'div\' + x;

		document.getElementById(dynalinks).className = \'dlink\';
		if(dynalinks==linkId)
		document.getElementById(dynalinks).className = \'dlink current\';
		
		document.getElementById(dynadiv).style.display=\'none\';
	}';
	$output .= '
	document.getElementById(divId).style.display=\'block\';
}';
	$output .= '</script>';

	
        
      
	
	
	$output .= '<div id="links" class="top color2">';
	$lc = 1;
	foreach ($last_posts as $posts) {
		if (($cph_limit == 0) || ($lc < $cph_limit+1)) {
			if($lc==1)
				$output .= "<a href=\"javascript:swaplayers('link".($lc)."','div".($lc)."');\" id=\"link".($lc)."\" class=\"dlink current\">".$posts->cat_name."</a>";
			else
				$output .= "<a href=\"javascript:swaplayers('link".($lc)."','div".($lc)."');\" id=\"link".($lc)."\" class=\"dlink \">".$posts->cat_name."</a>";
		}
		$lc++;
	}
	$output .= '</div><div class="guts"><div class="guts2"><div class="pad">';
	
	$limit_check = 0;
	foreach ($last_posts as $posts) {

		if (($cph_limit == 0) || ($limit_check < $cph_limit)) {
		
			if($limit_check == 0)
				$output .= '<div id="div'.($limit_check+1).'" style="display: block;">';
			else
				$output .= '<div id="div'.($limit_check+1).'"  style="display: none;">';
			
			
			$output .= '<h2><a href="'. get_permalink($posts->ID) . '" rel="bookmark" title="Permanent Link to ' . $posts->post_title . '">' . $posts->post_title . '</a></h2>';
			$output .= '<small>' . date_i18n("F jS, Y", strtotime($posts->post_date)); 
		

	    $result = "SELECT COUNT(*) FROM $wpdb->comments WHERE comment_approved = '1' AND comment_post_ID = '" . $posts->ID . "'"; 
			$num_comments = $wpdb->get_var($result);
			
			$output .= ' - <a href="' . get_permalink($posts->ID) . '#respond" title="Comment on ' . $posts->post_title . '">';
			if ($num_comments != 0) {
				$output .= $num_comments . ' Comment';
				if ($num_comments != 1) {
					$output .= 's';
				}
			}else{
				$output .= 'No Comments';
			}
			$output .= '</a></small>';

			$the_text = $wpdb->get_var("SELECT post_content FROM " . $tp . "posts WHERE ID=" . $posts->ID);
			$output .= '<p>';
			$output .= substr(strip_tags(trim($the_text)) , 0, $cph_chars);
			if (strlen(strip_tags(trim($the_text))) > $cph_chars) {
				$output .= " [...]";
			}

			$output .= '</p>';
			$output .= '<span style="padding:0 0 0 400px;"><a href="' . get_permalink($posts->ID) . '" title="Continue reading ' . $posts->post_title . '">Read more</a></span>';
			$output .= '</div>';
		} 
		$limit_check++;

	}

	$output .= '</div></div></div><div class="base"></div>';

	return $output;
}


add_action('admin_menu', 'cph_add_option_pages'); 




?>